﻿@page "/view"
@using HotelAppServerSide.Data
@using Microsoft.EntityFrameworkCore
@using HotelData.DatabaseAccess
@inject IDbContextFactory<HotelDataContext> HotelDataContextFactory
@inject HotelDataService DataService
@attribute [StreamRendering]
@rendermode InteractiveServer

<PageTitle>Find Your Reservation</PageTitle>

@if (ShowNotFoundMessage)
{
    <MudItem>
        <MudPaper Class="pa-4 ma-4 rounded-lg" Elevation="3" Style="@($"color:{Theme.Palette.Dark}; background:{Theme.Palette.ErrorDarken};")">
            <MudText Style="@($"color:{Theme.Palette.White}")">
                We could not find any reservations with the provided values. Did you write everything correctly?
            </MudText>
        </MudPaper>
    </MudItem>
}

@if (ShowDeletedMessage)
{
    <MudItem>
        <MudPaper Class="pa-4 ma-4 rounded-lg" Elevation="3" Style="@($"color:{Theme.Palette.Dark}; background:{Theme.Palette.SuccessDarken};")">
            <MudText Style="@($"color:{Theme.Palette.White}")">
                Your reservation has been successfully deleted.
            </MudText>
        </MudPaper>
    </MudItem>
}


<MudContainer Class="mt-4" MaxWidth="MaxWidth.ExtraLarge">
    <MudGrid Spacing="2">
        <MudItem xs="6">
            <MudPaper Class="pa-4 rounded-lg" Style="@($"background:{Colors.DeepPurple.Lighten5};")" Elevation="3">
                <MudText Typo="Typo.h6">Search for your reservation</MudText>

                <MudItem Class="mt-2">
                    <MudTextField T="string" Label="First Name" @bind-Value="@FirstName" ErrorText="Please enter your first name" Error="@ShowErrors[0]" />
                </MudItem>
                <MudItem>
                    <MudTextField T="string" Label="Last Name" @bind-Value="@LastName" ErrorText="Please enter your last name" Error="@ShowErrors[1]" />
                </MudItem>
                <MudItem>
                    <MudTextField T="string" Label="Person ID" @bind-Value="@PersonID" ErrorText="Please enter your ID" Error="@ShowErrors[2]" Mask="@(new PatternMask("00000000000"))" />
                </MudItem>
                <MudItem>
                    <MudTextField T="string" Label="Email" @bind-Value="@Email" ErrorText="The provided value is not a valid email" Error="@ShowErrors[3]" />
                </MudItem>
                <MudItem Class="mt-4">
                    <MudButton Variant="Variant.Filled" Color="Color.Primary" ButtonType="ButtonType.Button"
                               OnClick="OnSearchClicked"
                               Disabled="@SearchButtonDisabled">
                        Search
                    </MudButton>
                </MudItem>
            </MudPaper>
        </MudItem>

        <MudItem xs="6">
            @if (ShowSearchResults)
            {
                @if (NextReservation != null)
                {
                    <MudItem>
                        <MudPaper Class="pa-4 rounded-lg" Style="@($"background:{Colors.DeepPurple.Lighten5};")" Elevation="3">
                            <MudText Typo="Typo.h5">
                                Ongoing/Upcoming Reservation (Please note that you can only cancel reservations that are more than 3 days away)
                            </MudText>

                            @if (NextReservation.Count == 0)
                            {
                                <MudPaper Class="pa-4 mt-2 rounded-lg" Style="@($"background:{Colors.Purple.Lighten5};")">
                                    <MudText>No active reservations at the moment.</MudText>
                                </MudPaper>
                                
                            }
                            else
                            {
                                <MudItem Class="mt-2">
                                    <MudTable Items="@NextReservation" Style="@($"background:{Colors.Purple.Lighten5};")">
                                        <ColGroup>
                                            <col style="width:50px;" />
                                            <col style="width:200px;" />
                                            <col style="width:200px;" />
                                            <col />
                                            <col style="width:100px;" />
                                        </ColGroup>
                                        <RowTemplate>
                                            <MudTd>@context.RoomName</MudTd>
                                            <MudTd>Start Date - @context.GetStartDateString()</MudTd>
                                            <MudTd>End Date - @context.GetEndDateString()</MudTd>
                                            <MudTd>
                                                Price -
                                                @HelperFunctions.GetReservationCost(
                                             DataService.HotelRooms.First(x => x.RoomNumber == context.RoomName).DayCost,
                                             context.StartDate,
                                             context.EndDate) €
                                            </MudTd>
                                            <MudTd>
                                                @if (CanDelete(NextReservation[0]))
                                                {
                                                    <MudButton Variant="Variant.Filled" Color="Color.Primary"
                                                               OnClick="@(() => DeleteNextReservation(NextReservation[0]))"
                                                               Disabled="@DeleteButtonDisabled">Cancel</MudButton>
                                                }
                                            </MudTd>
                                        </RowTemplate>
                                    </MudTable>
                                </MudItem>
                            }
                        </MudPaper>
                    </MudItem>
                }

                @if (PastReservations.Count > 0)
                {
                    <MudPaper Class="mt-2 pa-4 rounded-lg" Style="@($"background:{Colors.DeepPurple.Lighten5};")" Elevation="3">
                        <MudItem>
                            <MudText Typo="Typo.h5">Past Reservations</MudText>
                        </MudItem>
                        <MudItem Class="mt-2">
                            <MudTable Items="@PastReservations" 
                                      Height="50vx" 
                                      Style="@($"color:{Colors.Purple.Lighten5};background:{Colors.Purple.Lighten5};")">
                                <ColGroup>
                                    <col style="width:50px;" />
                                    <col style="width:200px;" />
                                    <col style="width:200px;" />
                                    <col />
                                    <col style="width:100px;" />
                                </ColGroup>
                                <HeaderContent>
                                    <MudTh>Room</MudTh>
                                    <MudTh><MudTableSortLabel InitialDirection="SortDirection.Ascending" SortBy="new Func<Reservation, object>(x=>x.StartDate)">Start Date</MudTableSortLabel></MudTh>
                                    <MudTh>End Date</MudTh>
                                    <MudTh>Price</MudTh>
                                </HeaderContent>
                                <RowTemplate>
                                    <MudTd >@context.RoomName</MudTd>
                                    <MudTd>@context.GetStartDateString()</MudTd>
                                    <MudTd>@context.GetEndDateString()</MudTd>
                                    <MudTd>
                                        @HelperFunctions.GetReservationCost(
                                         DataService.HotelRooms.First(x => x.RoomNumber == context.RoomName).DayCost,
                                         context.StartDate,
                                         context.EndDate) €
                                    </MudTd>
                                    <MudTd></MudTd>
                                </RowTemplate>
                            </MudTable>
                        </MudItem>
                        
                    </MudPaper>
                    
                }
            }
        </MudItem>
    </MudGrid>
</MudContainer>